# encoding: UTF-8

module Vines
  module Command
    class Register
      def run(opts)
        raise 'vines register <login> <password> <domain>' unless opts[:args].size == 3
        require opts[:config]

        login, password, domain = opts[:args]

        create_user(domain, login, password)
      end

      def create_user(domain, jid, password)
        user = User.new(jid: [jid, domain].join('@'),
          password: BCrypt::Password.create(password).to_s)

        storage = Storage::Local.new { dir(Config.instance.storage(domain).dir) }
        storage.save_user(user)
        
        puts "Created user #{user.jid} with password #{password}"
      end

    end
  end
end
